<?php

namespace JsonRpc\Providers;

use Illuminate\Support\ServiceProvider;
use JsonRpc\Client;


class ClientServiceProvider extends ServiceProvider
{

    protected $defer = true;

    /**
     * Register any application services.
     *
     * @return void
     */
    public function register()
    {
        $this->app->configure('rpc');
        $this->app->log->info("call client service provider log");
        $config = config('rpc.client');

        $this->app->singleton('rpc', function () use ($config) {
            return new Client($config);
        });

        foreach ($config as $k => $item) {
            $this->app->singleton('rpc.' . $k, function () use ($k) {
                return app('rpc')->endpoint($k);
            });
        }
    }

    public function provides()
    {
        return parent::provides(); // TODO: Change the autogenerated stub
    }
}